Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/App_Code/ChartHelper.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/App_Code/ChartHelper.cshtml	(revision 9625)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/App_Code/ChartHelper.cshtml	(revision 9628)
@@ -1,3 +1,22 @@
-﻿@helper AjaxDataRenderer() {
+﻿@* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ *@
+
+@helper AjaxDataRenderer() {
     <script>
         var ajaxDataRenderer = function (url, plot, options) {
@@ -25,4 +44,8 @@
                 show: true,
                 sizeAdjust: 7.5
+            },
+            seriesDefaults: {
+                markerOptions: { show: false },
+                //fill: true
             },
             dataRenderer: ajaxDataRenderer,
@@ -52,5 +75,10 @@
             cursor: {
                 show: true,
-                tooltipLocation:'sw'
+                showTooltip: false,
+                zoom: true,
+                looseZoom: true,
+                clickReset: false,
+                dblClickReset: false,
+                constrainZoomTo: 'x'
             }
         });
@@ -58,6 +86,12 @@
         @(destinationTag)Plot.replot( {resetAxes:true} );
         
+        $('#@destinationTag').contextmenu(function() {
+            @(destinationTag)Plot.resetZoom();
+            @(destinationTag)Plot.replot( {resetAxes: true} );
+            return false;
+        });
+        
         $(window).resize(function() {
-            @(destinationTag)Plot.replot( {resetAxes:true} );
+            @(destinationTag)Plot.replot( {resetAxes: true} );
         });
     </script>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/ChartDataController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/ChartDataController.cs	(revision 9625)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/ChartDataController.cs	(revision 9628)
@@ -27,4 +27,5 @@
 
 namespace HeuristicLab.Services.Hive.Statistics.Controllers {
+  //[OutputCache(Duration = 60 * 5)]
   public class ChartDataController : Controller {
     private static readonly TimeSpan DefaultDuration = new TimeSpan(1, 0, 0, 0);
@@ -71,6 +72,7 @@
           };
 
+        // Return values in GB
         return Json(
-          CreateSeriesData(data.ToList(), x => x.Time, x => x.UsedMemory, x => x.TotalMemory),
+          CreateSeriesData(data.ToList(), x => x.Time, x => x.UsedMemory / 1000, x => x.TotalMemory / 1000),
           JsonRequestBehavior.AllowGet);
       }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/HomeController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/HomeController.cs	(revision 9625)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Controllers/HomeController.cs	(revision 9628)
@@ -29,6 +29,4 @@
   public class HomeController : Controller {
     public ActionResult Index() {
-      OverallStatus result = null;
-
       using (var db = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString)) {
         var onlineSlaves = (from slave in db.Resources.OfType<Slave>()
@@ -37,5 +35,5 @@
                            .ToList();
 
-        result = new OverallStatus {
+        var result = new OverallStatus {
           OverallCurrentlyAvailableCores = onlineSlaves.Sum(s => s.Cores ?? 0),
           CurrentlyAvailableCores = onlineSlaves.Where(s => s.IsAllowedToCalculate).Sum(s => s.Cores ?? 0),
@@ -49,7 +47,8 @@
                                     : 0.0
         };
+
+
+        return View(result);
       }
-
-      return View(result);
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/HeuristicLab.Services.Hive.Statistics-3.3.csproj
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/HeuristicLab.Services.Hive.Statistics-3.3.csproj	(revision 9625)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/HeuristicLab.Services.Hive.Statistics-3.3.csproj	(revision 9628)
@@ -110,5 +110,4 @@
     <Compile Include="Controllers\ChartDataController.cs" />
     <Compile Include="Controllers\HomeController.cs" />
-    <Compile Include="Helper\HtmlChartHelper.cs" />
     <Compile Include="Models\OverallStatistics.cs" />
     <Compile Include="Global.asax.cs">
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Views/Home/Index.cshtml
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Views/Home/Index.cshtml	(revision 9625)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Statistics/3.3/Views/Home/Index.cshtml	(revision 9628)
@@ -66,5 +66,5 @@
         "UsedMemory",
         Url.Action("UsedMemory", "ChartData"),
-        title: "Memory / Used Memory",
+        title: "Memory / Used Memory (GB)",
         minY: 0)
 }