Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/EmptyEvent.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/EmptyEvent.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/EmptyEvent.cs	(revision 9630)
@@ -19,6 +19,4 @@
     private EmptyEvent(EmptyEvent original, Cloner cloner)
       : base(original, cloner) {
-      this.Prefix = "";
-      this.Suffix = "";
     }
 
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnBulletHit.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnBulletHit.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnBulletHit.cs	(revision 9630)
@@ -3,46 +3,39 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    [StorableClass]
-    public class OnBulletHit : CodeNode
-    {
-        public override int MinimumArity { get { return 2; } }
-        public override int MaximumArity { get { return 10; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class OnBulletHit : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 10; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private OnBulletHit(bool deserializing) : base(deserializing) { }
-        private OnBulletHit(OnBulletHit original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "\r\npublic void onBulletHit(BulletHitEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    [StorableConstructor]
+    private OnBulletHit(bool deserializing) : base(deserializing) { }
+    private OnBulletHit(OnBulletHit original, Cloner cloner)
+      : base(original, cloner) {
 
-        public OnBulletHit()
-            : base("OnBulletHit", "This method is called when one of your bullets hits another robot.")
-        {
-            this.Prefix = "\r\npublic void onBulletHit(BulletHitEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new OnBulletHit(this, cloner);
-        }
+    public OnBulletHit()
+      : base("OnBulletHit", "This method is called when one of your bullets hits another robot.") {
+      this.Prefix = "\r\npublic void onBulletHit(BulletHitEvent e) {\r\n";
+      this.Suffix = "\r\nexecute();\r\n}\r\n";
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            string result = "";
-            foreach (ISymbolicExpressionTreeNode c in children)
-                result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-            return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OnBulletHit(this, cloner);
     }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = "";
+      foreach (ISymbolicExpressionTreeNode c in children)
+        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    }
+  }
 }
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnBulletMissed.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnBulletMissed.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnBulletMissed.cs	(revision 9630)
@@ -3,46 +3,39 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    [StorableClass]
-    public class OnBulletMissed : CodeNode
-    {
-        public override int MinimumArity { get { return 2; } }
-        public override int MaximumArity { get { return 10; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class OnBulletMissed : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 10; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private OnBulletMissed(bool deserializing) : base(deserializing) { }
-        private OnBulletMissed(OnBulletMissed original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "\r\npublic void onBulletMissed(BulletMissedEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    [StorableConstructor]
+    private OnBulletMissed(bool deserializing) : base(deserializing) { }
+    private OnBulletMissed(OnBulletMissed original, Cloner cloner)
+      : base(original, cloner) {
 
-        public OnBulletMissed()
-            : base("OnBulletMissed", "This method is called when one of your bullets misses, i.e. hits a wall.")
-        {
-            this.Prefix = "\r\npublic void onBulletMissed(BulletMissedEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new OnBulletMissed(this, cloner);
-        }
+    public OnBulletMissed()
+      : base("OnBulletMissed", "This method is called when one of your bullets misses, i.e. hits a wall.") {
+      this.Prefix = "\r\npublic void onBulletMissed(BulletMissedEvent e) {\r\n";
+      this.Suffix = "\r\nexecute();\r\n}\r\n";
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            string result = "";
-            foreach (ISymbolicExpressionTreeNode c in children)
-                result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-            return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OnBulletMissed(this, cloner);
     }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = "";
+      foreach (ISymbolicExpressionTreeNode c in children)
+        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    }
+  }
 }
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitByBullet.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitByBullet.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitByBullet.cs	(revision 9630)
@@ -3,46 +3,39 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    [StorableClass]
-    public class OnHitByBullet : CodeNode
-    {
-        public override int MinimumArity { get { return 2; } }
-        public override int MaximumArity { get { return 10; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class OnHitByBullet : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 10; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private OnHitByBullet(bool deserializing) : base(deserializing) { }
-        private OnHitByBullet(OnHitByBullet original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "\r\npublic void onHitByBullet(HitByBulletEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    [StorableConstructor]
+    private OnHitByBullet(bool deserializing) : base(deserializing) { }
+    private OnHitByBullet(OnHitByBullet original, Cloner cloner)
+      : base(original, cloner) {
 
-        public OnHitByBullet()
-            : base("OnHitByBullet", "This method is called when your robot is hit by a bullet.")
-        {
-            this.Prefix = "\r\npublic void onHitByBullet(HitByBulletEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new OnHitByBullet(this, cloner);
-        }
+    public OnHitByBullet()
+      : base("OnHitByBullet", "This method is called when your robot is hit by a bullet.") {
+      this.Prefix = "\r\npublic void onHitByBullet(HitByBulletEvent e) {\r\n";
+      this.Suffix = "\r\nexecute();\r\n}\r\n";
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            string result = "";
-            foreach (ISymbolicExpressionTreeNode c in children)
-                result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-            return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OnHitByBullet(this, cloner);
     }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = "";
+      foreach (ISymbolicExpressionTreeNode c in children)
+        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    }
+  }
 }
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitRobot.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitRobot.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitRobot.cs	(revision 9630)
@@ -3,46 +3,38 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    [StorableClass]
-    public class OnHitRobot : CodeNode
-    {
-        public override int MinimumArity { get { return 2; } }
-        public override int MaximumArity { get { return 10; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class OnHitRobot : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 10; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private OnHitRobot(bool deserializing) : base(deserializing) { }
-        private OnHitRobot(OnHitRobot original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "\r\npublic void onHitRobot(HitRobotEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    [StorableConstructor]
+    private OnHitRobot(bool deserializing) : base(deserializing) { }
+    private OnHitRobot(OnHitRobot original, Cloner cloner)
+      : base(original, cloner) {
+    }
 
-        public OnHitRobot()
-            : base("OnHitRobot", "This method is called when your robot collides with another robot.")
-        {
-            this.Prefix = "\r\npublic void onHitRobot(HitRobotEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    public OnHitRobot()
+      : base("OnHitRobot", "This method is called when your robot collides with another robot.") {
+      this.Prefix = "\r\npublic void onHitRobot(HitRobotEvent e) {\r\n";
+      this.Suffix = "\r\nexecute();\r\n}\r\n";
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new OnHitRobot(this, cloner);
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OnHitRobot(this, cloner);
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            string result = "";
-            foreach (ISymbolicExpressionTreeNode c in children)
-                result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-            return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
-        }
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = "";
+      foreach (ISymbolicExpressionTreeNode c in children)
+        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
     }
+  }
 }
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitWall.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitWall.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnHitWall.cs	(revision 9630)
@@ -3,46 +3,39 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    [StorableClass]
-    public class OnHitWall : CodeNode
-    {
-        public override int MinimumArity { get { return 2; } }
-        public override int MaximumArity { get { return 10; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class OnHitWall : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 10; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private OnHitWall(bool deserializing) : base(deserializing) { }
-        private OnHitWall(OnHitWall original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "\r\npublic void onHitWall(HitWallEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    [StorableConstructor]
+    private OnHitWall(bool deserializing) : base(deserializing) { }
+    private OnHitWall(OnHitWall original, Cloner cloner)
+      : base(original, cloner) {
 
-        public OnHitWall()
-            : base("OnHitWall", "This method is called when your robot collides with a wall.")
-        {
-            this.Prefix = "\r\npublic void onHitWall(HitWallEvent e) {\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new OnHitWall(this, cloner);
-        }
+    public OnHitWall()
+      : base("OnHitWall", "This method is called when your robot collides with a wall.") {
+      this.Prefix = "\r\npublic void onHitWall(HitWallEvent e) {\r\n";
+      this.Suffix = "\r\nexecute();\r\n}\r\n";
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            string result = "";
-            foreach (ISymbolicExpressionTreeNode c in children)
-                result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-            return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OnHitWall(this, cloner);
     }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = "";
+      foreach (ISymbolicExpressionTreeNode c in children)
+        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    }
+  }
 }
Index: branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnScannedRobot.cs
===================================================================
--- branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnScannedRobot.cs	(revision 9612)
+++ branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/OnScannedRobot.cs	(revision 9630)
@@ -3,52 +3,42 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    [StorableClass]
-    public class OnScannedRobot : CodeNode
-    {
-        public override int MinimumArity { get { return 2; } }
-        public override int MaximumArity { get { return 10; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class OnScannedRobot : CodeNode {
+    public override int MinimumArity { get { return 2; } }
+    public override int MaximumArity { get { return 10; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private OnScannedRobot(bool deserializing) : base(deserializing) { }
-        private OnScannedRobot(OnScannedRobot original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "\r\npublic void onScannedRobot(ScannedRobotEvent e) {" +
-                          "\r\ndouble absoluteBearing = getHeading() + e.getBearing();" +
-                          "\r\ndouble bearingFromGun = normalRelativeAngleDegrees(absoluteBearing - getGunHeading());" +
-                          "\r\nsetTurnGunRight(bearingFromGun);\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    [StorableConstructor]
+    private OnScannedRobot(bool deserializing) : base(deserializing) { }
+    private OnScannedRobot(OnScannedRobot original, Cloner cloner)
+      : base(original, cloner) {
 
-        public OnScannedRobot()
-            : base("OnScannedRobot", "This method is called when your robot sees another robot, i.e. when the robot's radar scan \"hits\" another robot.")
-        {
-            this.Prefix = "\r\npublic void onScannedRobot(ScannedRobotEvent e) {" +
-                          "\r\ndouble absoluteBearing = getHeading() + e.getBearing();" +
-                          "\r\ndouble bearingFromGun = normalRelativeAngleDegrees(absoluteBearing - getGunHeading());" +
-                          "\r\nsetTurnGunRight(bearingFromGun);\r\n";
-            this.Suffix = "\r\nexecute();\r\n}\r\n";
-        }
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new OnScannedRobot(this, cloner);
-        }
+    public OnScannedRobot()
+      : base("OnScannedRobot", "This method is called when your robot sees another robot, i.e. when the robot's radar scan \"hits\" another robot.") {
+      this.Prefix = "\r\npublic void onScannedRobot(ScannedRobotEvent e) {" +
+                    "\r\ndouble absoluteBearing = getHeading() + e.getBearing();" +
+                    "\r\ndouble bearingFromGun = normalRelativeAngleDegrees(absoluteBearing - getGunHeading());" +
+                    "\r\nsetTurnGunRight(bearingFromGun);\r\n";
+      this.Suffix = "\r\nexecute();\r\n}\r\n";
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            string result = "";
-            foreach (ISymbolicExpressionTreeNode c in children)
-                result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
-            return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OnScannedRobot(this, cloner);
     }
+
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      string result = "";
+      foreach (ISymbolicExpressionTreeNode c in children)
+        result += "\r\n" + ((CodeNode)c.Symbol).Interpret(c, c.Subtrees);
+      return this.Prefix + "\r\n" + result + "\r\n" + this.Suffix;
+    }
+  }
 }