Index: branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9634)
@@ -438,5 +438,5 @@
 
         refreshableJob.Progress.Status = "Downloading tasks...";
-        downloader = new TaskDownloader(allTasks.Select(x => x.Id), refreshableJob.Log);
+        downloader = new TaskDownloader(allTasks.Select(x => x.Id));
         downloader.StartAsync();
 
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HiveDataContext.cs	(revision 9634)
@@ -23,11 +23,8 @@
 using System.Data.Linq.Mapping;
 namespace HeuristicLab.Services.Hive.DataAccess {
-  partial class SlaveStatistics {
-  }
-
   partial class HiveDataContext {
     // source: http://stackoverflow.com/questions/648196/random-row-from-linq-to-sql
     [Function(Name = "NEWID", IsComposable = true)]
-    public Guid Random() { 
+    public Guid Random() {
       // to prove not used by our C# code... 
       throw new NotImplementedException();
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/Program.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/Program.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/Program.cs	(revision 9634)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/Properties/AssemblyInfo.cs.frame	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/Properties/AssemblyInfo.cs.frame	(revision 9634)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2013 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs	(revision 9634)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -33,5 +33,7 @@
     public static HiveOperationContext Current {
       get {
-        return OperationContext.Current.Extensions.Find<HiveOperationContext>();
+        return OperationContext.Current != null
+          ? OperationContext.Current.Extensions.Find<HiveOperationContext>()
+          : null;
       }
     }
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IOptimizedHiveDao.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IOptimizedHiveDao.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Interfaces/IOptimizedHiveDao.cs	(revision 9634)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -19,5 +19,4 @@
  */
 #endregion
-
 
 using System;
@@ -50,22 +49,6 @@
     #endregion
 
-    #region StateLog Methods
-
-    #endregion
-
-    #region Job Methods
-
-    #endregion
-
-    #region JobPermission Methods
-
-    #endregion
-
     #region Plugin Methods
     Plugin GetPluginById(Guid pluginId);
-    #endregion
-
-    #region PluginData Methods
-
     #endregion
 
@@ -79,34 +62,7 @@
     #endregion
 
-    #region SlaveGroup Methods
-
-    #endregion
-
     #region Resource Methods
     IEnumerable<Guid> GetAssignedResourceIds(Guid jobId);
     #endregion
-
-    #region ResourcePermission Methods
-
-    #endregion
-
-    #region Authorization Methods
-
-    #endregion
-
-    #region Lifecycle Methods
-
-    #endregion
-
-    #region Downtime Methods
-    #endregion
-
-    #region Statistics Methods
-
-    #endregion
-
-    #region UserPriority Methods
-
-    #endregion
   }
 }
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/OptimizedHiveDao.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/OptimizedHiveDao.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/OptimizedHiveDao.cs	(revision 9634)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,5 +28,9 @@
 namespace HeuristicLab.Services.Hive.DataAccess {
   public class OptimizedHiveDao : IOptimizedHiveDao {
-    private static HiveDataContext Db { get { return HiveOperationContext.Current.DataContext; } }
+    private HiveDataContext Db { get; set; }
+
+    public OptimizedHiveDao(HiveDataContext db) {
+      Db = db;
+    }
 
     #region Task Methods
@@ -181,16 +185,4 @@
     #endregion
 
-    #region StateLog Methods
-
-    #endregion
-
-    #region Job Methods
-
-    #endregion
-
-    #region JobPermission Methods
-
-    #endregion
-
     #region Plugin Methods
     public Plugin GetPluginById(Guid pluginId) {
@@ -203,9 +195,4 @@
       select p
     );
-
-    #endregion
-
-    #region PluginData Methods
-
     #endregion
 
@@ -249,8 +236,4 @@
     #endregion
 
-    #region SlaveGroup Methods
-
-    #endregion
-
     #region Resource Methods
     public IEnumerable<Guid> GetAssignedResourceIds(Guid taskId) {
@@ -264,31 +247,4 @@
     );
     #endregion
-
-    #region ResourcePermission Methods
-
-    #endregion
-
-    #region Authorization Methods
-
-    #endregion
-
-    #region Lifecycle Methods
-
-    #endregion
-
-    #region Downtime Methods
-    #endregion
-
-    #region Statistics Methods
-
-    #endregion
-
-    #region UserPriority Methods
-
-    #endregion
-
-    #region Helpers
-
-    #endregion
   }
 }
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 9616)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/ServiceLocator.cs	(revision 9634)
@@ -42,9 +42,10 @@
     }
 
-    private IOptimizedHiveDao optimizedHiveDao;
     public IOptimizedHiveDao OptimizedHiveDao {
       get {
-        if (optimizedHiveDao == null) optimizedHiveDao = new OptimizedHiveDao();
-        return optimizedHiveDao;
+        var dataContext = HiveOperationContext.Current != null
+                            ? HiveOperationContext.Current.DataContext
+                            : new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
+        return new OptimizedHiveDao(dataContext);
       }
     }