Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 9637)
@@ -20,5 +20,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Mtom" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false" />
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.MultiSlavesRunner/3.3/app.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.MultiSlavesRunner/3.3/app.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.MultiSlavesRunner/3.3/app.config	(revision 9637)
@@ -25,5 +25,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Mtom" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false" />
@@ -88,5 +88,5 @@
     <HeuristicLab.Clients.Hive.SlaveCore.MultiSlavesRunner.Properties.Settings>
       <setting name="NumberOfSlaves" serializeAs="String">
-        <value>16</value>
+        <value>2</value>
       </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.MultiSlavesRunner.Properties.Settings>
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 9637)
@@ -13,5 +13,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Mtom" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false" />
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 9637)
@@ -24,5 +24,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Mtom" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false" />
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 9637)
@@ -35,4 +35,7 @@
     }
 
+    private HiveServiceLocator() {
+    }
+
     private string username;
     public string Username {
@@ -47,11 +50,11 @@
     }
 
-    private int endpointRetries;
+    public int EndpointRetries { get; private set; }
 
-    private string workingEndpoint;
+    public string WorkingEndpoint { get; private set; }
 
     private HiveServiceClient NewServiceClient() {
-      if (endpointRetries >= Settings.Default.MaxEndpointRetries) {
-        return CreateClient(workingEndpoint);
+      if (EndpointRetries >= Settings.Default.MaxEndpointRetries) {
+        return CreateClient(WorkingEndpoint);
       }
 
@@ -63,14 +66,14 @@
           var cl = CreateClient(endpointConfigurationName);
           cl.Open();
-          workingEndpoint = endpointConfigurationName;
+          WorkingEndpoint = endpointConfigurationName;
           return cl;
         }
         catch (Exception exc) {
           exception = exc;
-          endpointRetries++;
+          EndpointRetries++;
         }
       }
 
-      throw exception;
+      throw exception ?? new Exception("No endpoint for Hive service found.");
     }
 
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/Settings.Designer.cs
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/Settings.Designer.cs	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/Settings.Designer.cs	(revision 9637)
@@ -26,5 +26,5 @@
         [global::System.Configuration.ApplicationScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("16")]
+        [global::System.Configuration.DefaultSettingValueAttribute("2")]
         public int MaxParallelUploads {
             get {
@@ -93,5 +93,5 @@
         [global::System.Configuration.ApplicationScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("5")]
+        [global::System.Configuration.DefaultSettingValueAttribute("3")]
         public int MaxEndpointRetries {
             get {
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/Settings.settings
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/Settings.settings	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/Settings.settings	(revision 9637)
@@ -4,5 +4,5 @@
   <Settings>
     <Setting Name="MaxParallelUploads" Type="System.Int32" Scope="Application">
-      <Value Profile="(Default)">16</Value>
+      <Value Profile="(Default)">2</Value>
     </Setting>
     <Setting Name="HLBinaryName" Type="System.String" Scope="Application">
@@ -29,5 +29,5 @@
     </Setting>
     <Setting Name="MaxEndpointRetries" Type="System.Int32" Scope="Application">
-      <Value Profile="(Default)">5</Value>
+      <Value Profile="(Default)">3</Value>
     </Setting>
   </Settings>
Index: /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/app.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/app.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Clients.Hive/3.3/app.config	(revision 9637)
@@ -9,5 +9,5 @@
     <HeuristicLab.Clients.Hive.Settings>
       <setting name="MaxParallelUploads" serializeAs="String">
-        <value>16</value>
+        <value>2</value>
       </setting>
       <setting name="HLBinaryName" serializeAs="String">
@@ -36,5 +36,5 @@
       </setting>
       <setting name="MaxEndpointRetries" serializeAs="String">
-        <value>5</value>
+        <value>3</value>
       </setting>
     </HeuristicLab.Clients.Hive.Settings>
@@ -50,5 +50,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Mtom" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
+        <binding name="wsHttpBinding_Hive" closeTimeout="00:01:00" openTimeout="00:01:00" receiveTimeout="00:20:00" sendTimeout="00:20:00" bypassProxyOnLocal="false" transactionFlow="false" hostNameComparisonMode="StrongWildcard" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647" messageEncoding="Text" textEncoding="utf-8" useDefaultWebProxy="true" allowCookies="false">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647"/>
           <reliableSession ordered="true" inactivityTimeout="00:10:00" enabled="false"/>
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/App.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/App.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive.SelfHost/3.3/App.config	(revision 9637)
@@ -59,5 +59,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="WSHttpBinding_IHiveService" messageEncoding="Mtom" receiveTimeout="00:15:00" sendTimeout="00:10:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+        <binding name="WSHttpBinding_IHiveService" messageEncoding="Text" receiveTimeout="00:15:00" sendTimeout="00:10:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <security mode="Message">
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config	(revision 9636)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config	(revision 9637)
@@ -59,5 +59,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="WSHttpBinding_IHiveService" messageEncoding="Mtom" receiveTimeout="00:15:00" sendTimeout="00:10:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+        <binding name="WSHttpBinding_IHiveService" messageEncoding="Text" receiveTimeout="00:15:00" sendTimeout="00:10:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <security mode="Message">